//*****************************************************************************
//                    Laborprojekt, FH-Wedel 2005
//-----------------------------------------------------------------------------
//
// Modul:       - enthlt Funktionen fr die Ausgabe im Log-Fenster
//
//-----------------------------------------------------------------------------
// Datum:       Copyright 2005, Andreas Schibilla
//*****************************************************************************
#include <windows.h>
#include <stdio.h>
#include "resource.h"
#include "log.h"


extern HWND   g_hMainWnd;   // Handle des Hauptfenster aus main.cpp


//*****************************************************************************
// Funktion:    Lscht das Log-Fenster
//-----------------------------------------------------------------------------
// Parameter:   -
// Return:      -
//-----------------------------------------------------------------------------
// Datum:       2005-05-06, Andreas Schibilla
//*****************************************************************************
void ClearLog(void)
{                         
 SetDlgItemText(g_hMainWnd, IDE_LOG, "");
}



//*****************************************************************************
// Funktion:    Gibt einen Text im Log-Fenster aus (Syntax hnlich wie printf)
//-----------------------------------------------------------------------------
// Parameter:   s  - Formatstring
// Return:      -
//-----------------------------------------------------------------------------
// Datum:       2005-05-06, Andreas Schibilla
//*****************************************************************************
void Log(char *s, ...)
{
 va_list     pz;
 char        buf[1024*100];
 char        num[50];
 
 if (s == NULL)
   return;

 va_start(pz, s);

 strcpy(buf, "");
 while(*s)              // Formatstring durchlaufen
   {
    if(*s != '%')       // ist keine Formatangabe?
      {
         char c[2];
         c[0] = *s;
         c[1] = '\0';
         strcat(buf, c);
      }
    else                // behandel Formatangabe
    {
      switch(*++s)
        {
          case 's': strcat(buf, va_arg(pz, char *) );           // String 
                  break;
    
          case 'd': sprintf(num, "%d", va_arg(pz, int));        // Dezimalzahl
                  strcat(buf, num);
                  break;

          case 'f': sprintf(num, "%.2f", va_arg(pz, double));   // Fliekommazahl
                  strcat(buf, num);
                  break;


          default:  {
                          char c[2];
                          c[0] = *s;
                          c[1] = '\0';
                          strcat(buf, c);
                         }
                  break;
        }
    }
      ++s;     
   }
    
 va_end(pz);
 HWND hLog = GetDlgItem(g_hMainWnd, IDE_LOG);
 SendMessage(hLog, EM_REPLACESEL,0,(LPARAM)((LPSTR) buf) );  
}

